﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Serialization;

namespace Barsalt.ParameterSystem.Container {
	/// <summary>
	/// <para>The IParameterMap defines the functions that need to be implemented by any group container in the ParameterArchive.</para>
	/// 
	/// <para> - The OnDistribution() function is called by the ParameterArchive. Its return value are the keys of all entries that were changed since the last distribution.</para>
	/// </summary>
	public interface IParameterMap {
		#region INTERFACE_FUNCTIONS
		//==========================================================================
		bool Add(string key, object value);

		bool Update(string key, object value);

		bool Remove(string key);

		Type GetType(string key);

		bool IsTypeOf(string key, Type type);

		T GetValue<T>(string key);

		bool ContainsKey(string key);

		List<string> OnDistribution();

		List<string> Keys{
			get;
		}
		//==========================================================================
		#endregion
	}
}
