﻿using System.Collections;
using System.Collections.Generic;
using System;

namespace Barsalt.ParameterSystem.Exceptions {
	class PreferenceTypeException : Exception {
		#region OBJECT_ATTRIBUTES
		//==========================================================================
		private Type requestedType;
		private object value;
		private string key;
		//==========================================================================
		#endregion

		#region CONSTRUCTOR
		//==========================================================================
		public PreferenceTypeException(Type requestedType, string key, object value) : base("VALUE[" + value + "] of KEY[" + key + "] has TYPE[" + value.GetType() + "] and not TYPE[" + requestedType + "]") {
			this.requestedType = requestedType;
			this.value = value;
			this.key = key;
		}
		//==========================================================================
		#endregion

		#region GETTER_AND_SETTER
		//==========================================================================
		public Type RequestedType{
			get{
				return requestedType;
			}
		}

		public Type ValueType {
			get {
				return value.GetType();
			}
		}

		public object Value{
			get{
				return value;
			}
		}

		public string Key {
			get {
				return key;
			}
		}
		//==========================================================================
		#endregion
	}
}
