﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using UnityEngine;

namespace Barsalt.WindowSystem.Components {
	/// <summary>
	/// The ResizeSystem resizes a Rect based on the position and activates buttons of the mouse. The interface for resizeing is the Resize() function.  
	/// </summary>
	public sealed class FocusSystem {
		
		private readonly List<BaseWindow> WINDOWS = new List<BaseWindow>();

		public void Add(BaseWindow window){
			WINDOWS.Add(window);
		}

		public void Remove(BaseWindow window){
			WINDOWS.Remove(window);
		}

		public void GetFocus(BaseWindow window){
			foreach(BaseWindow item in WINDOWS){
				item.IsFocused = false;
			}

			window.IsFocused = true;


			GUI.FocusWindow(window.ID);
		
		}
	}
}